/**
 * Created by Matjaz on 10/06/14.
 */


function updateRulesListOriginal($fc, values, fn) {
    if(values[fn]) {
        var $ul = $('<ul/>').appendTo($fc);
        var last_media = null;
        $.each(values[fn], function(i,r) {
            //if(r.indexOf('crsa-') === 0) return true;
            var media = r.media ? r.media : null;

            if(last_media != media) {
                if(last_media) {
                    $ul = $ul.parent().closest('ul');
                }
                if(media) {
                    var $li = $('<li/>').appendTo($ul).html('<div class="crsa-cm-media">' + media + '</div>').data('media', media);
                    $ul = $("<ul/>").appendTo($li);
                }
            }
            last_media = media;

            var $ric = $('<li/>', { 'class' : 'crsa-input-rule-c'}).appendTo($ul).data('crsa-rule', r);
            var $ri = $('<a/>', {'class' : 'crsa-input-rule', 'href' : '#'}).html(r.selector).appendTo($ric);
            if(r.type == 'class') {
                var $remove = $('<a/>', {'class' : 'crsa-input-rule-remove', 'href' : '#'}).html('x').appendTo($ric);
            }
        });
        if(last_media) {
            $ul = $ul.parent().closest('ul');
        }
    }
    var $ric = $('<div/>', { 'class' : 'crsa-input-rule-c'}).appendTo($fc);
    var $ri = $('<a/>', {'class' : 'crsa-input-rule', 'href' : '#'}).html('+ Add Class').appendTo($ric);

    var $rule_props = $('<div/>', {'class' : 'crsa-rule-props'}).appendTo($fc);

    $fc.find('a.crsa-input-rule-remove').on('click', function(event) {
        var $ri = $(event.delegateTarget);
        var $ric = $ri.parent();
        var rule = $ric.data('crsa-rule');
        var $el = selectedElement.data;
        $el.removeClass(rule.class);
        var newValues = getValuesForObject(selectedElement);
        $fc.html('');
        updateRulesList($fc, $el, newValues, fn);
        event.preventDefault();
    });

    var $cm = $("#crsa-rules-out .panel-content");
    var $el = selectedElement.data;

    $fc.find('a.crsa-input-rule').on('click', function(event) {
        var $ri = $(event.delegateTarget);
        var $ric = $ri.parent();
        var rule = $ric.data('crsa-rule');
        var new_rule = false;

        if(!rule) {
            //new class
            var $rules_div = $('#crsa-rules');
            $cm.html('').append($rules_div);
            $("#crsa-rules-out").data('panel').show();

            //selectedPage.crsacss('showClassManager', $cm, true, $el);


            /*
             var prompt_str = "Please enter the name for the new class:";
             while(true) {
             rule = prompt(prompt_str);

             if(!rule) return false;

             var $rules = selectedPage.crsacss('find', '.' + rule);
             if($rules.length > 0) {
             prompt_str = "Class with the name " + rule + " already exists. Please choose a different name:";
             } else if(!rule.match(/^-?[_a-zA-Z]+[_a-zA-Z0-9-]*$/)) {
             prompt_str = "Name must contain only letters, numbers, '-' and '_'. Please choose a different name:";
             } else {
             new_rule = true;
             break;
             }
             }*/
        }
        if(rule) {
            if(new_rule) {
                if(rule.type == 'class') {
                    $el.addClass(rule);
                }
                var rule_obj = getObjectFromRule(rule);

                selectedPage.crsacss('addRule', rule_obj.selector + ' {}');
                var newValues = getValuesForObject(selectedElement);
                $fc.html('');
                updateRulesList($fc, $el, newValues, fn);
                methods.showProperties(rule_obj, $fc.find('> .crsa-rule-props'));

            } else {
                var rule_obj = getObjectFromRule(rule);
                methods.showProperties(rule_obj, $fc.find('> .crsa-rule-props'));
            }
        }
        event.preventDefault();
    });
    $cm.off('crsa-cm-class-selected').on('crsa-cm-class-selected', function(event, rule_info) {
        var sel = rule_info.selector;
        if(rule_info.type == 'class') {
            //class
            var c = rule_info.class;
            willMakeChange(selectedPage, getElementName($el) + ' | Add class ' + c);
            $el.addClass(c);
            selectElement($el);
            didMakeChange(selectedPage);
            /*
             var rule_obj = getObjectFromRule(rule_info);
             var newValues = getValuesForObject(selectedElement);
             $fc.html('');
             updateRulesList($fc, newValues, fn);*/
            // methods.showProperties(rule_obj, $fc.find('> .crsa-rule-props'));

            //  selectedPage.crsacss('closeClassManager', $cm);
        }
    });
    $cm.off('crsa-cm-new').on('crsa-cm-new', function(event, sel) {
        selectedPage.crsacss('addLessRule', sel, {}, function(rule) {
            if(rule.type == 'class') {
                $el.addClass(rule.class);
            }
            var rule_obj = getObjectFromRule(rule);
            // selectedPage.crsacss('addRule', rule_obj.selector + ' {}');
            var newValues = getValuesForObject(selectedElement);
            $fc.html('');
            updateRulesList($fc, $el, newValues, fn);
            methods.showProperties(rule_obj, $fc.find('> .crsa-rule-props'));

            selectedPage.crsacss('closeClassManager', $cm);
        });
    });
}

//Depreceated
var CrsaPlacer = function() {

    var $placer = $('#crsa-placer');
    var $content = $placer.find('.panel-content');

    var tooltipShown = false;

    this.def = null;
    this.$element = null;
    this.clone = false;
    this.$cloneSource = null;
    this.$target = null;
    this.undoRecorded = false;

    var _this = this;

    $body.on('crsa-element-selected', function(event, obj) {
        if($placer.is(':visible')) {
            if(obj && obj.type == 'element') {
                this.undoRecorded = false;
                var $el = obj.data;
                var $iframe = getIframeOfElement($el);
                _this.$target = $el;
                if(!_this.$element || _this.$element.get(0) != $el.get(0)) {
                    showDropTarget($iframe, $el, _this.$element, _this.def);
                }
            } else {
                showDropTarget(null, null, _this.$element, _this.def);
            }
        }
    });

    var getTarget = function() {
        if(selectedElement && selectedElement.type == 'element') {
            if(_this.$element && selectedElement.data.get(0) == _this.$element.get(0)) {
                return selectedElement.data.is('body') ? null : selectedElement.data.parent();
            }
            return selectedElement.data;
        }
        return null;
    }

    this.setDef = function(def) {
        this.def = def;
        this.$element = null;
        this.clone = false;
        this.$cloneSource = null;
        this.$target = this.$target ? this.$target : getTarget();
        this.undoRecorded = false;
        showDropTarget(selectedPage, this.$target, null, _this.def);
    }

    this.setElement = function($el, clone) {
        this.$element = $el;
        this.clone = clone;
        this.$cloneSource = clone ? $el : null;
        if(this.def) {
            $('li.crsa-factory-element.selected').removeClass('selected');
            this.def = null;
        }
        var t = getTarget();
        this.$target = t;
        if(clone) {
            this.$element = $el.clone(true);
            removeCrsaClasses(this.$element);
        }
        this.undoRecorded = false;
        showDropTarget(selectedPage, t, this.$element, null);
    }


    var showDropTarget = function($iframe, $pel, $el) {
        $placer.find('div.crsa-drop-target').remove();
        var $main = $('<div class="crsa-drop-target"></div>');
        var $d = $main;

        var def = _this.def;
        if($el) {
            def = getType($el);
        } else if(_this.$cloneSource) {
            def = getType(_this.$cloneSource);
        }

        if(!$iframe || !$pel || !def) {
            $('<div class="alert alert-info">Select the target element...</div>').appendTo($d);
        } else {
            $('<div class="alert alert-info">Select the position for <strong>' + def.name + '</strong>:</div>').appendTo($d);

            var $drop = $pel;
            var parents = [];

            if(!$pel.is('body')) {
                do {
                    $drop = $drop.parent();
                    if($drop.length == 0) {
                        break;
                    }
                    parents.push($drop.get(0));
                }
                while(!$drop.is('body') && parents.length < 3);
            }

            var placed = false;

            for(var i = parents.length - 1; i >= 0; i--) {
                var $p = $(parents[i]);
                $d = $('<div class="crsa-drop-parent"></div>').html(getElementName($p, null, true, false, false)).appendTo($d).data('parent', $p);
            }
            $d = $('<div class="crsa-drop-selected"></div>').appendTo($d);

            $('<span/>').html(getElementName($pel, null, true, false, false )).appendTo($d);

            var $children = $pel.children().filter(function(i) {
                if(getType($(this))) return true;
                return false;
            });
            $('<div/>', {class: 'crsa-drop-loc crsa-drop-loc-prepend'}).data('loc','prependTo').data('loc-el', $pel).appendTo($d);

            $children.each(function(i, ch) {
                var $ch = $(ch);
                $('<div/>', {class: 'crsa-drop-child'}).data('child',$ch).html(getElementName($ch, null, true, false, false )).appendTo($d);
                if(i != $children.length - 1) {
                    $('<div/>', {class: 'crsa-drop-loc crsa-drop-loc-after'}).data('loc','insertAfter').data('loc-el', $ch).appendTo($d);
                }
            });

            $('<div/>', {class: 'crsa-drop-loc crsa-drop-loc-append'}).data('loc','appendTo').data('loc-el', $pel).appendTo($d);

            var placeOn = function($loc) {
                crsaWillChangeDom();
                var loc = $loc.data('loc');
                var $locEl = $loc.data('loc-el');
                if(!$el) {
                    $el = _this.$cloneSource ? _this.$cloneSource.clone(true) : createElementFromDefinition(def);
                    removeCrsaClasses($el);
                }
                $el[loc]($locEl);
                scrollCanvasToElement($el, $iframe);
            }

            $d.find('.crsa-drop-loc')
                .on('mouseover', function(e) {

                    var $loc = $(e.delegateTarget);
                    placeOn($loc);
                    highlightElement($el);
                    $el.addClass('crsa-placed');
                })
                .on('mouseout', function(e) {
                    if($el) {
                        $el.detach();
                        highlightElement(null);
                        $el.removeClass('crsa-placed');
                    }
                })
                .on('click', function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    var $loc = $(e.delegateTarget);

                    if(!_this.undoRecorded) {
                        if($el) {
                            $el.detach();
                        }
                        willMakeChange($iframe, 'Placed / ' + def.name);
                        if($el) {
                            placeOn($loc);
                        }
                        _this.undoRecorded = true;
                    }

                    placed = true;
                    if(!$el) {
                        placeOn($loc);
                    }
                    $el.removeClass('crsa-placed');
                    methods.updateStructureAndWireAllElemets($iframe, $el.parent(), true);
                    //selectElement($el);
                    highlightElement(null);

                    didMakeChange($iframe, $el.parent());
                    elementWasInserted($el);
                    /*
                     if(!tooltipShown) {
                     $el.tooltip({container: 'body', placement: 'top', title: 'Placed! Click again to place another.', trigger: 'manual'});
                     $el.tooltip('show');
                     tooltipShown = true;
                     var $tel = $el;
                     setTimeout(function() {
                     $tel.tooltip('destroy');
                     }, 2000);
                     }
                     */
                    $el = null;
                    var t = $main.scrollTop();
                    showDropTarget($iframe, $pel, $el);
                    $placer.find('div.crsa-drop-target').scrollTop(t);
                });

            $d.find('.crsa-drop-child')
                .on('mouseover', function(e) {
                    var $pel = $(e.delegateTarget).data('child');
                    highlightElement($pel);
                    scrollCanvasToElement($pel, $iframe);
                })
                .on('mouseout', function(e) {
                    var $pel = $(e.delegateTarget).data('child');
                    highlightElement(null);
                })
                .on('click', function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    var $pel = $(e.delegateTarget).data('child');
                    selectElement($pel);
                    scrollCanvasToElement($pel, $iframe);
                    showDropTarget($iframe, $pel, $el);
                });

            $main.find('.crsa-drop-parent')
                .on('click', function(e) {
                    e.preventDefault();
                    e.stopPropagation();
                    var $p = $(e.delegateTarget).data('parent');
                    selectElement($p);
                    scrollCanvasToElement($p, $iframe);
                    showDropTarget($iframe, $p, $el);
                });
        }
        $content.append($main);

        if(!$placer.is(':visible')) {
            $placer.show();
        }
    }
}
