/*
Copyright: Humane tehnologije d.o.o.
 */

var PgPageViewPlayer = function($container, $iframe, pageView) {

    var url;
    var iframe = $iframe.get(0);

    //var $iframe;
    var event_handler = new PgEventHandler(0, 0 /* first position */);

    var getHtml = function() {
        if(!iframe.contentDocument) return null;
        return iframe.contentDocument.documentElement;
    }

    var eventPlayer = new PgNodeEventDOMPlayer($iframe, pageView);

    event_handler.on_event = function(event) {

        if(event.page !== pageView.getPage()) return;

        var html = getHtml();
        if(html) {
            eventPlayer.play(event, html);
        }
    }

    var showUI = function() {
        //$iframe = $('<iframe class="page-view-iframe" frameborder="0" nwdisable="nwdisable" nwfaketop="nwfaketop" src=""></iframe>').appendTo($container);
    }

    showUI();

    this.open = function(page) {
        /*
        var args = ['pgid=' + page.uid, 'pgedit=1'];
        args.push('pglive=1');

        var pgurl = page.url;

        pgurl = page.getCompatibleUrl(pgurl);
        pgurl = crsaAppendQueryToUrl(pgurl, args);

        $iframe.attr('src', pgurl);
        */
        event_handler.start();
    }

    this.destroy = function() {
        event_handler.destroy();
        eventPlayer.destroy();
    }
}

