var PgStartScreenView = function() {

    var $element = $('<div class="pg-start-screen"><div class="left"></div><div class="right"></div></div>');

    //var $pine = $('<i class="icon icon-pine"></i>').appendTo($element);

    var $right = $element.find('.right');

    var new_text = pgf.kids ? 'New project' : 'New page or project';

    var $opens_left = $('<ul class="icons">\
                <li class="menu-file-template remove-in-cm"><a href="#"><i class="icon icon-281"></i><b>' + new_text + '</b></a></li>\
                </ul><hr class="pgf_edit_html">');

    var right_html = '<ul class="icons">';

    if(pgf.kids) {
        //right_html += '<li class="menu-file-template remove-in-cm"><a href="#"><i class="icon icon-281"></i><b>' + new_text + '</b></a></li>';
    } else {
        $opens_left.appendTo($element.find('.left'));

        right_html += '<li class="menu-file-open-file"><a href="#"><i class="icon icon-278"></i><b>Open file</b></a></li>';
        right_html += '<li class="menu-file-open-url remove-in-cm"><a href="#"><i class="icon icon-279"></i><b>Open url</b></a></li>';
        right_html += '<li class="menu-file-open-project"><a href="#"><i class="icon icon-project"></i><b>Open project</b></a></li>';
    }

    var $opens_right = $(right_html + '</ul>').appendTo($right);

    var $recent = $(`<div class="recent-files"><h2>${pgf.kids ? 'My projects' : 'Open recent'}</h2><ul></ul></div>`);

    if(!pgf.kids) {
        $('<hr>').appendTo($right);
        $recent.appendTo($right);
    }

    if(pgf.kids) {
        var $info = $('<div class="info"><div class="info-inner pg-lessons-chapter"></div></div>').appendTo($right);
    }

    var $lessons = $('<div class="lessons" style="display:none;"><h2>Adventures</h2><ul></ul></div>').appendTo($right);
    
    var $projects = $('<div class="projects"><h2>Projects</h2><ul></ul></div>').appendTo($right);

    var $docs = $('<hr><h2>Help &amp; Support</h2><ul class="links">\
    <li class=""><a href="https://pinegrow.com/docs/getting-started/pinegrow-walkthrough-video/" target="_blank" class="external pgf_docs_intro_video">Pinegrow walkthrough - Video</a></li>\
                <li><a href="help://intro" target="_blank" class="external pgf_docs_quick_intro">Quick introduction to Pinegrow</a></li>\
        <li><a href="help://docs.index" target="_blank" class="external pgf_help_url">Documentation</a></li>\
                <!--<li><a href="#" class="menu-support-tutorial remove-in-cm">Play with Pinegrow tutorial</a></li>-->\
                <li class="remove-in-cm"><a href="https://www.youtube.com/channel/UCo2RGSbsI9GIxVvJPXanUuw/playlists" target="_blank" class="menu-video-tutorials pgf_docs_video_tutorials">Video Tutorials</a></li>\
                <li><a href="https://pinegrow.com#contact" target="_blank" class="menu-support-portal pgf_support_url">Support</a></li>\
                </ul>');

    if(!pgf.kids) {
        $docs.appendTo($right);
    }

    //$('<iframe width="560" height="315" src="https://www.youtube.com/embed/tX_lIropt2A?rel=0" frameborder="0" allowfullscreen></iframe>').appendTo($docs);

    crsaHandleExternalLinks($docs);

    var $version = $('<div class="version-info"><h4>An update is available for download</h4><p>Pinegrow 3 is the most amazing piece of software every created in the universe.</p><p><button class="pg-button" href="#">Learn more &amp; download</button></p></div>').appendTo($right).hide();

    updateProductInfoIn$Element($element);

    var view = this.view = new PgUIView($element);

    view.onResize = function() {
    }

    view.onDestroy = function() {
    }

}

var PgStartScreenManager = function() {
    var view = new PgStartScreenView();

    var $full = $('<div id="pg-start-screen-container"></div>').appendTo($('body'));

    var is_full = false;
    var scroll_top = 0;

    var showFull = function() {
        if(!is_full) {
            pinegrow.recentFiles.populate();//update

            is_full = true;
            $full.show();
            $full.append(view.view.get$Element());

            view.view.get$Element().scrollTop(scroll_top);
            pgQuickWindowManager.closeAll();

            $('.menu-open-library,.menu-current-project,.menu-project-menu').hide();
            $('.navbar-brand .logo-name').show();

            pinegrow.buttonToolbarTopCenter && pinegrow.buttonToolbarTopCenter.hide();
        }
    }

    var hideFull = function() {
        if(is_full) {
            scroll_top = view.view.get$Element().scrollTop();

            $full.hide();
            is_full = false;
            if(pinegrow.buttonToolbarTopCenter) {
                pinegrow.buttonToolbarTopCenter.show();
                pinegrow.buttonToolbarTopCenter.customReposition();
            }

            $('.menu-open-library,.menu-current-project,.menu-project-menu').show();
            $('.navbar-brand .logo-name').hide();

            /*
            if(pinegrow.getSetting('ui-zoom', '0') == '0') {
                if($('body').width() < 1400) {
                    if(!localStorage.pg_adjusted_ui_to_size4) {
                        localStorage.pg_adjusted_ui_to_size4 = '1';
                        setUIZoom(-1);
                        pinegrow.setSetting('ui-zoom', '-1');

                        pinegrow.showAlert('<p>The size of Pinegrow window is a bit small, so the UI size was decreased to 75% in order to fit more information on the screen.</p><p>You can change the UI size at any time using the <i class="icon icon-zoom" style="color:black;"></i> icon on the right side of the top toolbar.</p>', 'Just made the UI smaller for you');
                    }
                }
            }*/
        }
    }

    showFull();

    if(pinegrow.recentFiles.isEmpty()) {
        if(pgf.empty_recent_list_notice) {
            var $div = $(`<li class="pg-start-screen-notice"><i class="icon icon-left"></i>${pgf.empty_recent_list_notice}</li>`);

            $div.insertAfter($full.find('.menu-file-open-project'));
        }
    }

    var onFileProjectLoaded = function() {
        hideFull();
    }

    var onFileProjectClosed = function() {
        if(pinegrow.getCurrentProject() == null && pinegrow.getAllPages().length == 0) {
            showFull();
        }
    }

    this.isVisible = function() {
        return is_full;
    }

    pinegrow.addEventHandler('on_page_view_started_loading', onFileProjectLoaded);
    pinegrow.addEventHandler('on_project_loaded', onFileProjectLoaded);

    pinegrow.addEventHandler('on_project_closed', onFileProjectClosed);
    pinegrow.addEventHandler('on_page_closed', onFileProjectClosed);

    $('body').on('crsa-recent-files-item-clicked', hideFull);
}