/**
 * Created by Matjaz on 11/2/13.
 */

var crsaBoxShadowControl = function() {


    var shadows = [];

    var parseValue = function(value) {
        shadows = [];
        var list = value.split(/\s*,\s*/);
        $.each(list, function(i, s) {
            if(!s || s.length == 0) return true;
            var tokens = [];
            var par_level = 0;
            var n = 0;
            var token = '';

            for(var j = 0; j < s.length; j++) {
                var token_done = false;
                var ch = s.charAt(j);

                if(ch == ' ') {
                    if(token.length > 0) {
                        token_done = true;
                    }
                } else {
                    token += ch;
                }
                if(token_done) {
                    tokens.push(token);
                    n++;
                    token = '';
                }
            }
            var ok = true;
            if(tokens.length < 2) {
                ok = false;
            } else {
                var x = tokens[0];
                var y = tokens[1];
                var inset = tokens[tokens.length-1].toLowerCase() == 'inset';
                if(inset) {
                    tokens.pop();
                }
                var blur = null;
                var spread = null;
                var color = null;

                if(tokens.length == 5) {
                    blur = tokens[2];
                    spread = tokens[3];
                    color = tokens[4];
                } else {
                    var last = tokens[tokens.length-1];
                    var last_is_color = last.indexOf('@') >= 0 || last.indexOf('#') >= 0 || last.indexOf('(') >= 0 || last.test(/^[a-z]*$/i);
                    if(last_is_color) {
                        color = last;
                        tokens.pop();
                    }
                    if(tokens.length == 4) {
                        blur = tokens[2];
                        spread = tokens[3];
                    } else if(tokens.length == 3) {
                        blur = tokens[2];
                    }
                }
                shadows.push({x : x, y : y, blur : blur, spread : spread, color : color, inset : inset});
            }
        });
    }

    this.setValue = function(value) {

    }


}