(function( $ ){

    var data = {};
    var init_done = false;
    var changed = {};
    var content_changed = {};
    var set_name_on_save = false;
    var slug_edited = true;
    
    var msb = null;
    //var show_tabs = false;
    
    var settings = {
      'get_data' : '/cob/callSmarty/Skill.notes/externalGetUserNotes/',
      'save_data' : '/cob/callSmarty/MsbElement/externalSaveEditableArea/',
      'delete_site' : '/cob/callSmarty/MsbElement/externalDeleteSite/',
      'save_data_bck' : '/cob/callSmarty/MsbElement/externalSaveEditableBck/',
      'url_base' : ''
    };   
                
    var key2slide_el = {};
    var elid2key = {};
    var elid2slide_el = {};
    
    var methods = {
       init : function( options ) {
           if ( options ) { 
               $.extend( settings, options );
           }
           
           this.each(function(i,e){
               var $e = $(e);
               var d = { key: options.key, label: options.label, description: options.description, url : options.url, inline: options.inline, position: options.position, id: options.id, auto_open: options.auto_open, id_text: options.id_text, id_title: options.id_title, auto_close: options.auto_close, show_len : options.show_len, edit_title: options.edit_title, rtf_content : options.rtf_content, obj_id : options.obj_id, edit_app: options.edit_app, edit_pllop: options.edit_pllop, full_edit : true, upload: options.upload_image, slide_el : options.slide_el, fb_app_id: options.fb_app_id };
               d.show_tabs = d.edit_app || d.edit_pllop;
               d.allow_hide = d.show_tabs;
               d.form_id = "notes_form_" + d.key
               
               if(options.no_edit_button) d.no_edit_button = true;
               
               if(options.set_name_on_save && d.edit_pllop) set_name_on_save = true;
               
               if('content' in options && options.content != '') data[d.key] = options.content;//.replace(/<br \/>/g,"\n");
               if('site_data' in options && options.site_data != '') data['site'] = options.site_data;
               if('profile_data' in options && options.profile_data != '') data['profile'] = options.profile_data;
//               if('content' in options && options.content != '') data[d.key] = jQuery.parseJSON(options.content);//.replace(/<br \/>/g,"\n");

               if(set_name_on_save && methods.getPllopSlug() == '') slug_edited = false;
               if(!methods.getPllopSlug()) {
                   data['site']['slug'] = methods.makeSlug(methods.getPllopName());
               }
               
               
               key2slide_el[d.key] = options.slide_el;
               elid2key[d.obj_id] = d.key;
               elid2slide_el[d.obj_id] = options.slide_el;
                
               $e.data('crsaNotes', d);
               
               $e.bind('crsaShowNotes', function(event) {
                   methods.onShowNotes($(event.currentTarget));
                   return false;
               });
               
               if(!d.no_edit_button) {
                methods.showEditIcon($e);
               }
               
               if(d.auto_open) methods.onShowNotes($e);
               
               $('#msb').bind('crsaNotesDataUpdated', {el: $e}, function(event) {
                   var $s = event.data.el;
                   methods.hideNotes($s, true);
                   methods.onShowNotes($s, true);
                   
                   methods.showContent(d);
               });
               $('#msb').bind('crsaNotesBeforeSave', {el: $e}, function(event, key) {
                   var $e = event.data.el;
                   methods.onBeforeSave($e);
                   return true;
               });
               $('#msb').bind('crsaNotesSaved', {el: $e}, function(event, key) {
                   var d = event.data.el.data('crsaNotes');
                   methods.showContent(d);
                   if(d.auto_close && (key == 0 || key == d.key)) {
                       var $f = $('#' + d.form_id);
                       if($f.length > 0) {
                           methods.hideNotes($f);
                       }
                   }
               });
               setInterval(function() {
                   try {
                       
                   
                   if(d.key in content_changed && content_changed[d.key]) {
                     methods.onBeforeSave($e);
                     methods.showContent(d, true);
                   //  content_changed[d.key] = false;
                   }
                   } catch(err) {}
               }, 1500);

           });
           if(!init_done) {
                msb = $('#msb');
                msb.bind('changed.crsa', function(e, data) {
                    var $el = data.e;
                    var d = $el.data('crsaNotes');
                    if(d) {
                        if(d.key) {
                            methods.dataForKeyChanged(d.key);
                        }
                    } else {
                        methods.dataForKeyChanged('site');
                        //$('#msb').trigger('crsaNotesUpdateChanged');
                    }
                });
                
                $('#msb').bind('crsaUserLoggedIn', function() {
                    if(!msb.crsaruntime('getCreateDerived')) {
                        $('#msb').crsaruntime('waitStart');
                        $.ajax({
                              url: settings.url_base + settings.get_data,
                              dataType: 'json',
                              type: 'post',
                              data: {},
                              beforeSend:function(request) { 
                                  request.setRequestHeader('X-Update', 'dummy');
                              },           
                              success: function(ret){
                                  data = ret.notes;
                                  $('#msb').trigger('crsaNotesDataUpdated');
                                  $('#msb').crsaruntime('waitDone');
                                 // methods.waitDone();
                              },
                                error: function(a,b,c) {
                                    //methods.waitDone();
                                    $('#msb').crsaruntime('waitDone');
                                    alert(a.responseText);
                                }          

                        });        
                    }              
                });
                
                window.onbeforeunload = function() {
                    var ch = false;
                    $.each(changed, function(i,e) {
                        if(e) ch = true;
                    });
                    if(ch) {
                        return 'Some changes you made are not saved. Are you sure that you want to leave this page without saving your notes?';
                    }
                    return null;
                };
  
                init_done = true;
           }
       },
       onBeforeSave : function($e) {
           var d = $e.data('crsaNotes');
           var hasc = false;
           if(!(d.key in data)) data[d.key] = {};
           var $f = $('#' + d.form_id);
           
           if(d.edit_title) {
            var $t = $f.find('textarea.sne_title');
            if($t.length > 0) {
                data[d.key]['title'] = $t.val();
                
            }
           }
           var $content = $f.find('textarea.sne_content');
           
           if($content.length > 0) {
               var edd = $content.data('crsaEditor');
               
               if(!edd) {
                   data[d.key]['text'] = $content.val();
               } else {
                   try {
                    data[d.key]['text'] = edd.Editor.getContent();
                   }
                   catch(err) {}
                  // console.log(data[d.key]['text']);
                   if(data[d.key]['text'] == '<p>&nbsp;</p>') {
                       data[d.key]['text'] = '';
                   }
               }
           }
           var $hide = $f.find('input.sne_hide');
           if($hide.length > 0) {
               data[d.key]['hide'] = $hide.is(':checked');
           }
           var $m = $f.find('input.sne_global_bck');
           if($m.length > 0) {
               data[d.key]['global_bck'] = $m.is(':checked');
           }
           var $m = $f.find('textarea.sne_media');
           if($m.length > 0) {
               data[d.key]['media'] = $m.val();
           }
           var $m = $f.find('input.sne_media_fbalbum');
           if($m.length > 0) {
               data[d.key]['media_fbalbum'] = $m.val();
           }
           var $m = $f.find('input.sne_media_soundcloud');
           if($m.length > 0) {
               data[d.key]['media_soundcloud'] = $m.val();
           }
           var $m = $f.find('input.sne_media_pllops');
           if($m.length > 0) {
               data[d.key]['media_pllops'] = $m.is(":checked");
           }
           //pllop data
           if(d.edit_pllop) {
               var $pname = $f.find('input.sne_pllop_name');
               if($pname.length > 0) data['site']['name'] = $pname.val();
               
               var $pslug = $f.find('input.sne_pllop_slug');
               if($pslug.length > 0) data['site']['slug'] = $pslug.val();

               var $p = $f.find('input.sne_pllop_desc');
               if($p.length > 0) data['site']['description'] = $p.val();
               
               var $pprivate = $f.find('input.sne_pllop_private');
               if($pprivate.length > 0) data['site']['private'] = $pprivate.is(':checked'); 

               var $pprivate = $f.find('input.sne_show_menu');
               if($pprivate.length > 0) data['site']['show_menu'] = $pprivate.is(':checked'); 

               var $pprivate = $f.find('input.sne_active');
               if($pprivate.length > 0) data['site']['active'] = $pprivate.is(':checked'); 

               var $p = $f.find('input.sne_pllop_gaid');
               if($p.length > 0) data['site']['gaid'] = $p.val();
               
               /*
               var $p = $f.find('.sne_fb_page_id');
               if($p.length > 0) data['site']['fb_page_id_done'] = $p.val();
               
               var $p = $f.find('.sne_fb_page_name');
               if($p.length > 0) data['site']['fb_page_name'] = $p.val();
               */
               
               if(!data.profile) data.profile = {};
               
               var $p = $f.find('input.sne_profile_name');
               if($p.length > 0) data['profile']['name'] = $p.val();
               
               var $p = $f.find('input.sne_profile_space');
               if($p.length > 0) data['profile']['space'] = $p.val();
               
               var $p = $f.find('input.sne_profile_email');
               if($p.length > 0) data['profile']['email'] = $p.val();

               var $p = $f.find('input.sne_page_name');
               if($p.length > 0) data[d.key]['name'] = $p.val();
               
               
               var $p = $f.find('input.sne_pages_order');
               if($p.length > 0) {
                   var v = $p.val();
                   if(v) {
                       data['site']['order'] = v;
                   }
               }
           }

       },
       showEditIcon : function($e) {
            $e.append('<a class="crsa-si-edit"></a>');
            $e.find('a.crsa-si-edit').click(function(e) {
                $e.trigger('crsaShowNotes');
                return false;
            });
       },
       showEditor : function($e, d) {
        try{ 
            var tinyMceAdvanced = {
                mode : "none",
                convert_urls : false,
                relative_urls : false,
                language: "en",
                theme : "advanced",
                plugins : "table,paste,media,tabfocus,inlinepopups",
                skin : "o2k7",
                skin_variant : "black",
                width:"100%",
                dialog_type : "modal",
                content_css : "/css/editstyle.css?r=114", //pastetext
                theme_advanced_buttons1 : "bold,underline,italic,strikethrough,separator,bullist,numlist,link,unlink,formatselect,separator,undo,redo,separator,justifyleft,justifycenter,justifyright,justifyfull,styleselect", 
                //theme_advanced_buttons2: "tablecontrols,styleselect,outdent,indent,blockquote",
                theme_advanced_buttons2: "",
                theme_advanced_buttons3: "",
                theme_advanced_toolbar_location : "top",
                theme_advanced_toolbar_align : "left",
                theme_advanced_statusbar_location : "bottom",
                extended_valid_elements : "hr[class|width|size|noshade],embed[style|id|type|src|flashvars|*]",
                invalid_elements :"div",
                paste_use_dialog : false,
                paste_text_sticky : true,
                setup : function(ed) {
                    ed.onInit.add(function(ed) {
                        ed.pasteAsPlainText = true;
                    });
                },
                paste_auto_cleanup_on_paste : true,
                paste_convert_headers_to_strong : true,
                theme_advanced_resizing : true,
                atheme_advanced_resize_horizontal : false,
                theme_advanced_styles : "credits=crsa-credits,kicker=kicker,capital-letter=drop-cap,run-in=run-in,pullquote=pullquote,quote=quote,qoute outside=quote_outside,background=crsa-text-bck",
                tab_focus : ':prev,:next',
                apply_source_formatting : true
            };                
            if(typeof tinyMCE == "undefined") {
                console.log(window.location.hostname);
                $.getScript('/js/tiny_mce/tiny_mce.js', function() {
                    tinyMCE.baseURL = '//' + window.location.hostname + '/js/tiny_mce/';
                    window.tinyMCEPreInit = {
                            base: '//' + window.location.hostname + '/js/tiny_mce/', 
                            suffix : '', 
                            query : ''
                    };                        
                    tinymce.dom.Event.domLoaded = true;
                    tinyMCE.init(tinyMceAdvanced);

                    methods.initEditor($e, d, tinyMceAdvanced);
                });
            } else {
                methods.initEditor($e, d, tinyMceAdvanced);
            }
        } catch(err) { alert(err); };
        //try{ tinyMCE.execCommand('mceRemoveControl', false, $e[0].id); } catch(err) {};
       },
       initEditor : function($e, d, conf) {
            var ed = new tinymce.Editor($e[0].id, conf);
            
            ed.render();
            var edd = { Editor: ed };
            edd.Dirty = false;
            edd.Interval = setInterval(function() {
                //console.log('is dirty_');
                try {
                    if(ed.isDirty() && edd.Dirty === false) {
                        content_changed[d.key] = true;
                        if((!(d.key in changed)) || changed[d.key] == false) {
                            changed[d.key] = true;
                            
                            $('#msb').trigger('crsaNotesUpdateChanged');
                        }                            
                        edd.Dirty = true;
                        $e.data('crsaEditor', edd);
                    }
                }
                catch(err) {}
            } ,100);
            
            $e.data('crsaEditor', edd);
       },
       embedGetWidth : function(m) {
       },
       showContent : function(d, live) {
           if(typeof live == 'undefined' || live === null) live = false;
           
           var $s = $('#' + d.id_text);
           var c = methods.getShowText(d.key, d.show_len);
           
           var m = '';
           
           if(!live) {
               var m = methods.getMedia(d.key);
               c = c + '<div class="crsa-media"></div>';
               
           }
           
           $s.html(c);
           
           if(!live) {
            var $md = $s.find('div.crsa-media');
            msb.unbind('crsaAfterResize.media');
            msb.crsaruntime('embedMedia', $md, m);

            var fba = methods.getMediaFBAlbum(d.key);
            if(fba) {
                msb.crsaruntime('fbShowAlbum', $md, fba);
            }
            var fba = methods.getMediaSoundcloud(d.key);
            if(fba) {
                msb.crsaruntime('soundcloudEmbed', $md, fba);
            }
            var pllops = methods.getMediaPllops(d.key);
            if(pllops) {
                $md.html('<p>The list of your other pllops will be shown here after you reload this pllop.</p>');
            }
           }
           
           var ugc = c != null && c != '';
           
           if(d.edit_title) {
               var str = methods.getShowTitle(d.key);
               var $t = $('#' + d.id_title);
               if($t.length == 0) {
                   $s.before('<h1 id="' + d.id_title + '"></h1>');
                   var $t = $('#' + d.id_title);
               }
               if(str) {
                $t.html(str);
                ugc = true;
               } else {
                   $t.remove();
               }
           }
           
           
           var ie = $s.closest('.crsa-inner, .msb_element');
           if(ugc) {
               ie.find('.hide-if-ugc').hide();
           } else {
               ie.find('.hide-if-ugc').show();
           }
           $('#msb').crsaruntime('makeVisible', ie);
           
       },
       getPageName : function(key) {
           return (key in data) && ('name' in data[key]) && data[key]['name'] ? data[key]['name'] : '';
       },
       getContent : function(key) {
           return (key in data) && ('text' in data[key]) && data[key]['text'] ? data[key]['text'] : '';
       },
       getAllContent : function() {
           var r = {};
           $.each(data, function(i,e) {
               var c = methods.getContent(i);
               if(c) r[i] = c;
           });
           return r;
       },
       getTitle : function(key) {
           return (key in data) && ('title' in data[key]) && data[key]['title'] ? data[key]['title'] : '';
       },       
       getHide : function(key) {
           return (key in data) && ('hide' in data[key]) && data[key]['hide'] ? data[key]['hide'] : false;
       },       
       getGlobalBck : function(key) {
           return (key in data) && ('global_bck' in data[key]) && data[key]['global_bck'] ? data[key]['global_bck'] : false;
       },       
       getPllopName : function() {
           return ('site' in data) && ('name' in data['site']) && data['site']['name'] ? data['site']['name'] : '';
       },       
       getPllopDesc : function() {
           return ('site' in data) && ('description' in data['site']) && data['site']['description'] ? data['site']['description'] : '';
       },       
       getPllopSlug : function() {
           return ('site' in data) && ('slug' in data['site']) && data['site']['slug'] ? data['site']['slug'] : '';
       },       
       getPllopActive : function() {
           return ('site' in data) && ('active' in data['site']) ? data['site']['active'] : 0;
       },       
       getFBAppId : function() {
           return ('site' in data) && ('fb_app_id' in data['site']) && data['site']['fb_app_id'] ? data['site']['fb_app_id'] : '';
       },       
       getFBAppName : function() {
           return ('site' in data) && ('fb_app_name' in data['site']) && data['site']['fb_app_name'] ? data['site']['fb_app_name'] : '';
       },       
       getShowMenu : function() {
           return ('site' in data) && ('show_menu' in data['site']) && data['site']['show_menu'] ? data['site']['show_menu'] : '';
       },       
       getGaId : function() {
           return ('site' in data) && ('gaid' in data['site']) && data['site']['gaid'] ? data['site']['gaid'] : '';
       },       
       getProfileName : function() {
           return ('profile' in data) && ('name' in data['profile']) && data['profile']['name'] ? data['profile']['name'] : '';
       },       
       getProfileSpace : function() {
           return ('profile' in data) && ('space' in data['profile']) && data['profile']['space'] ? data['profile']['space'] : '';
       },       
       getProfileEmail : function() {
           return ('profile' in data) && ('email' in data['profile']) && data['profile']['email'] ? data['profile']['email'] : '';
       },       
       getMedia : function(key) {
           return (key in data) && ('media' in data[key]) && data[key]['media'] ? data[key]['media'] : '';
       },       
       getMediaFBAlbum : function(key) {
           return (key in data) && ('media_fbalbum' in data[key]) && data[key]['media_fbalbum'] ? data[key]['media_fbalbum'] : '';
       },       
       getMediaPllops : function(key) {
           return (key in data) && ('media_pllops' in data[key]) && data[key]['media_pllops'] ? data[key]['media_pllops'] : '';
       },       
       getMediaSoundcloud : function(key) {
           return (key in data) && ('media_soundcloud' in data[key]) && data[key]['media_soundcloud'] ? data[key]['media_soundcloud'] : '';
       },       
       autop : function(s) {
           s = s.replace(/\n\n/g, "\n");
           var a = s.split("\n");
           var b = '';
           $.each(a, function(i,e) {
               if(e == '') e = '&nbsp;';
               b += '<p>' + e + '</p>';
           });
           return b;
       },
       onShowNotes : function($e, fast) {
            var msb = $('#msb');
            var uid = msb.crsaruntime('getUserId');
            var uemail = msb.crsaruntime('getUserEmail');

            var d = $e.data('crsaNotes');
            
            var $s = $('#' + d.form_id);
            
            if($s.length > 0) return;
            
            
            var cd = '';
            if(d.position && d.position == 'left') cd += ' skill_notes_left';
            if(d.inline) {
                cd += ' skill_notes_inline';
            } else {
                cd += ' skill_notes_outline';
            }
            
            var b = '<div id="' + d.form_id + '" class="skill_notes' + cd + '"'
            if(!fast) b += ' style="display:none;"';
            b += '>';
            
            if(d.show_tabs) {
                b += '<ul class="sntb">';
                b += '<li class="sntb_content">Content<small>image, title and text</small></li>';
                if(d.edit_app) {
                    b += '<li class="sntb_app">Appearance<small>Colors, fonts, positions...</small></li>';
                    b += '<li class="sntb_media">Media<small>Embed video, audio, maps...</small></li>';
                    b += '<li class="sntb_opt">Options</li>';
                }
                if(d.edit_pllop) {
                    b += '<li class="sntb_pllop">This pllop<small>Name, url, facebook...</small></li>';
                    b += '<li class="sntb_nav">Navigation<small>Menu, page order...</small></li>';
                    b += '<li class="sntb_pages">Pages</li>';
                    b += '<li class="sntb_profile">My Profile</li>';
                }
                b += '</ul>';
            }
            b += '<div class="skill_notes_head">';
            
            b += '<p class="skill_notes_label">' + d.label + '</p>';
            if(d.description != '') b += '<div class="skill_notes_desc">' + d.description + '</div>';
            
            b += '</div><div class="skill_notes_inner">';
            
            b += '<div class="sntbc">';
            
          //  if(d.full_edit) {
                b += '<div class="snt_content">';
           // }
            
            if(d.upload) {
                b += '<hr style="margin-top:0px;"/><div class="skill_notes_tw">';
                b += '<a class="skill_notes_upload crsa-button">Upload picture</a>&nbsp;<a class="skill_notes_remove_image" href="#">remove picture</a>\
                      <div class="skill_notes_global_bck"><input type="checkbox" class="sne_global_bck snchk" ';
            if(methods.getGlobalBck(d.key)) b += ' checked="checked" ';
            b += '/> Use as pllop background</div>\
                </div>';
            }
            b += '<form>';
            
            if(d.edit_title) {
                b += '<hr /><div class="skill_notes_tw skill_notes_tw_title"><span class="skill_notes_label">Title:</span><textarea class="sne_title" spellcheck="false" name="data[EA][title]">' + methods.getTitle(d.key) + '</textarea></div>';
            }
            var addc = '';
            if(d.rtf_content) addc = ' skill_notes_tw_rtf';
            b += '<hr /><div class="skill_notes_tw' + addc + '"><span class="skill_notes_label">Content:</span><textarea id="' + d.id_text + '_ta" class="sne_content" spellcheck="false" name="data[EA][content]">' + methods.getContent(d.key) + '</textarea></div>';
            
            b += '</form></div>';
            
            if(d.edit_app) {
                b += '<div class="snt_app"><hr style="margin-top:0px;"/><div class="skill_notes_tw"><div class="testek"><p>Please wait, loading...</p></div></div></div>';
                b += '<div class="snt_media">\
                <hr style="margin-top:0px;"/> \
                <div class="skill_notes_tw"><span class="skill_notes_label">Embed code:</span><textarea class="sne_media" spellcheck="false" name="data[EA][media]">' + methods.getMedia(d.key) + '</textarea><p>Save changes to show the updated media in the pllop.</p></div> \
                <hr /> \
                <div class="skill_notes_tw"><span class="skill_notes_label">Facebook Page Photo Album ID:</span><input class="sne_media_fbalbum sninput" spellcheck="false" name="data[EA][fb_album]" value="' + methods.getMediaFBAlbum(d.key) + '" /><p>Just enter the id number of the album url, for example<br />www.facebook.com/media/set/?set=a.<strong style="color:white;">111057189816</strong>.83244.95882014816</p></div>\
                <hr /> \
                <div class="skill_notes_tw"><span class="skill_notes_label">Soundcloud:</span><input class="sne_media_soundcloud sninput" spellcheck="false" name="data[EA][fb_soundcloud]" value="' + methods.getMediaSoundcloud(d.key) + '" /><p>Just enter the url of the artist, set or track, for example<br />http://soundcloud.com/willy-tea-taylor</p></div>';
                
                b += '<hr /><div class="skill_notes_tw"><span class="skill_notes_label">Show the list of my other pllops:</span> \
                      <p><input type="checkbox" class="sne_media_pllops snchk" ';
                if(methods.getMediaPllops(d.key)) b += ' checked="checked" ';
                b += '/> The list of all my other pllops will be shown here</p></div>';
                
                b += '</div>';
            }
            if(d.edit_pllop) {
                b += '<div class="snt_opt"></div>';
                b += '<div class="snt_pllop"></div>';
                b += '<div class="snt_nav"></div>';
                b += '<div class="snt_pages"></div>';
                b += '<div class="snt_profile"></div>';
            }
            b += '</div>';
            
            b += '<hr /><div class="skill_notes_foot">';
            if(uid) {
                b += '<p class="skill_notes_uinfo">Logged in as ' + uemail + '. <a href="/logout" class="logout action">Logout</a>.</p>';            
            }
            if(!uid && !msb.crsaruntime('getCreateDerived')) {
                b += '<a href="#" class="crsa-button crsa-button-big skill_notes_update">OK</a>';
                b += '<p class="skill_notes_uinfo"><a href="#" class="skill_notes_save yellow">I would like to save my notes.</a><br />';                
                b += '(<a href="#" class="skill_notes_login_pllop action">Login</a> to access your saved information.)</p>';
            } else {
                b += '<a href="#" class="crsa-button crsa-button-big skill_notes_save">Save all changes in this pllop</a>';
            }
            b += '</div></div>';

            b += '<a class="skill_notes_hide crsa-close" href="#">Hide</a></div>';
            
            if(!d.inline) {
                var $fd = $e.hasClass('crsa-slide') ? $e : $e.closest('.crsa-slide');
                $fd.append(b);
            } else {
                $('#' + d.id).after(b);
            }
            
            var $s = $('#' + d.form_id);

            if(!fast) $s.show();
            
            if(!d.inline) 
                methods.sizeTextarea($s);

            $s.find('ul.sntb').css('top', ($s.find('div.skill_notes_head').height() + 26) + 'px');
            
            var $content = $s.find('textarea.sne_content');
            
            if(d.rtf_content) {
                methods.showEditor($content, d);
            }
            if(d.show_tabs) {
                
                methods.showPageOptions($s.find('div.snt_opt'), d);
                
                var closeOtherTabs = function(sel) {
                    msb.find(sel).each(function(ind, ple) {
                        if($act[0] == ple) return true;
                        var $ple = $(ple);
                        if($ple.find('input').length > 0) {
                            $ple.html('');
                            var $nts = $ple.closest('div.skill_notes');
                            var i = 0;
                            $($nts.find('div.sntbc > div').hide().get(i)).show();
                            $($nts.find('ul.sntb > li').removeClass('selected').get(i)).addClass('selected');
                        }
                    });
                };
                
                $($s.find('div.sntbc > div').hide().get(0)).show();
                $s.find('li.sntb_content').addClass('selected');
                $s.find('ul.sntb li').click(function(e) {
                    var $t = $(e.currentTarget);
                    var i = $t.index();
                    $($s.find('div.sntbc > div').hide().get(i)).show();
                    $($s.find('ul.sntb > li').removeClass('selected').get(i)).addClass('selected');
                    
                    $act = $($s.find('div.sntbc > div').get(i));
                    
                    if($t.hasClass('sntb_pllop')) {
                        closeOtherTabs('div.snt_pllop');
                        methods.showPllopOptions($act, d);    
                    }
                    if($t.hasClass('sntb_profile')) {
                        closeOtherTabs('div.snt_profile');
                        methods.showMyProfile($act, d);    
                    }
                    if($t.hasClass('sntb_nav')) {
                        closeOtherTabs('div.snt_nav');
                        methods.showNavigation($act, d);    
                    }
                    if($t.hasClass('sntb_pages')) {
                        closeOtherTabs('div.snt_pages');
                        methods.showPages($act, d);    
                    }
                    
                    return false;
                });
            }
            /*
            $content.change(function(e) {
                data[d.key]['text'] = $(e.currentTarget).val();
            });*/
            $content.bind('input',function(e) {
                methods.dataForKeyChanged(d.key, true);
            });
            $s.find('input.sne_global_bck').change(function() {
                methods.dataForKeyChanged(d.key);
                alert('Save changes and reload the pllop to activate or deactivate this setting.');
            });
/*          
            $s.find('textarea.sne_title').change(function(e) {
                data[d.key]['title'] = $(e.currentTarget).val();
            });*/
            $s.find('textarea.sne_title,input.sninput').bind('input',function(e) {
                methods.dataForKeyChanged(d.key, true);
            });
            $s.find('input.sne_hide').bind('change',function(e) {
                methods.dataForKeyChanged(d.key);
            });
            $s.find('textarea.sne_media').bind('input',function(e) {
                methods.dataForKeyChanged(d.key);
            });
            $s.find('input.sne_media_pllops').bind('change',function(e) {
                methods.dataForKeyChanged(d.key);
            });                    
            
            $s.find('form').submit(function(e) {
                var uid = msb.crsaruntime('getUserId');
                
                if(!uid) {
                    $('#msb').crsaruntime('userRegistration', 'sel');
                    return false;
                }
                $('#msb').crsaruntime('waitStart');
            //    data[d.key]['text'] = $s.find('textarea.sne_content').val();
             //   data[d.key]['title'] = $s.find('textarea.sne_title').val();
                methods.save(d.key, 0);
                return false;
            });
            $s.find('a.skill_notes_upload').click(function(e) {
                msb.crsaui('showFileUpload', {notify_element: $e[0].id}, $e, e);
                return false;
            });
            $s.find('a.skill_notes_remove_image').click(function(e) {
                if(!(d.key in data)) data[d.key] = {};
                data[d.key]['bckpic'] = 'none';
                methods.dataForKeyChanged(d.key);
                $e.find('.msb_bcks > img').remove();
                return false;
            });
            
            
            $s.find('a.skill_notes_save').click(function(e) {
                if(set_name_on_save) {
                    $s.find('li.sntb_pllop').trigger('click');
                    alert('Give a name to your new Pllop before saving it!');
                    return false;
                }
                
                var uid = msb.crsaruntime('getUserId');
                
                if(!uid) {
                    methods.onBeforeSave($e);
                    methods.showContent(d);
                    $('#msb').crsaruntime('userRegistration', 'sel', function() {
                        $('#msb').crsaruntime('waitStart');
                        methods.save(0, 0);
                    });
                    return false;
                }
                $('#msb').crsaruntime('waitStart');
                
                methods.save(0, 0);
                return false;
            });
            $s.find('a.skill_notes_update').click(function(e) {
                methods.onBeforeSave($e);
                methods.showContent(d);
                methods.hideNotes($s);
                return false;
            });
            
            $s.find('a.logout').click(function(e) {
                msb.crsaruntime('logout');
                return false;
            });
            
            //$('#msb').bind('crsaNotesUpdateData', function
            
            $s.find('.skill_notes_hide').click(function() {
                methods.onBeforeSave($e);
                methods.hideNotes($s);
                return false;
            });
            
            $s.find('a.skill_notes_login_pllop').click(function() {
                var uid = msb.crsaruntime('getUserId');
                
                if(!uid) {
                    $('#msb').crsaruntime('userRegistration', 'sel');
                }
                return false;
            });

            $s.find('.skill_notes_login a.skill_notes_login_fb').click(function() {
                var uid = msb.crsaruntime('getUserId');
                
                if(!uid) {
                    $('#msb').crsaruntime('doFacebookLogin');
                }
                return false;
            });
            
            if(d.upload) {
                $e.bind('FileUploaded', function(event, file, r) {
                    var s = '1024w';
                    s = 'normal';
                    if(r.info && s in r.info) {
                        console.log('FileUploaded');
                        var url = r.info[s].url;
                        var w = r.info[s].width;
                        var h = r.info[s].height;
                        
                        //$e.crsanotes('saveBck', d.key, r.id);
                        var stretch = false;
                        var mb = $e.find('div.msb_bcks');
                        if(mb.length == 0) {
                            $e.prepend('<div class="msb_bcks"><img class="msb_element_bck"/></div>');
                            mb = $e.find('div.msb_bcks');
                            stretch = true;
                        }
                        var i = mb.find('> img');
                        if(i.length == 0) {
                            mb.append('<img class="msb_element_bck" />');
                            i = mb.find('> img');
                        }
                        i.attr('large', url);
                        i.attr('src', url);
                        i.data('owidth',w).data('oheight',h);
                        i.attr('data-owidth',w).attr('data-oheight',h);
                        
                   /*     if(stretch) {
                            $(window).bind('resize', function() {
                                var opt = {};
                                msb.crsaruntime('fsStretchImages', $e, opt);
                            });
                        }*/
                        
                        $(window).trigger('resize');
                        
                        if(!(d.key in data)) data[d.key] = {};
                        data[d.key]['bckpic'] = r.id;
                        methods.dataForKeyChanged(d.key);
                        
                        methods.logEvent('Image uploaded');
                    }
                });     
            }
                        
           $(window).resize(function() {
                methods.sizeTextarea($s);
           });       
           methods.updateChanged($s, d.key);
           $('#msb').bind('crsaNotesUpdateChanged', function() {
                methods.updateChanged($s, d.key);
           });     
           
           if(!fast) {
               $s.hide();
               $s.fadeIn(500);
           }
           if(!d.inline) {
               methods.adminFunc(function() {
                    $s.draggable({handle: '.skill_notes_head', containment: $s.parent()});
                    if(d.show_tabs) {
                        methods.loadSlideData($e, d.obj_id, function(r) {
                            var $tes = $s.find('.testek');
                           msb.crsaui('onEdit', null, $e[0].id, $tes, null, $e, true);
                           methods.setMaxHeightOnAccordion($s, $tes);
                        });
                    }                
               });
           }
        },
        logGoal : function(msg) {
            if(typeof clicky != 'undefined') {
                clicky.goal(msg);
            }
        },
        logEvent : function(msg) {
            if(typeof clicky != 'undefined') {
                clicky.log(window.location.href, msg);
            }
        },
        logPause : function(msg) {
            if(typeof clicky != 'undefined') {
                clicky.pause(500);
            }
        },
        setMaxHeightOnAccordion : function($s, $dest) {
           var mh = ($s.height() - $s.find('.skill_notes_head').height() - 250) + 'px';
           $dest.find('.ui-accordion-content').css('max-height',mh);
        },
        showPllopOptions : function($dest, d) {
            var b = '<hr style="margin-top:0px;"/><form><div class="skill_notes_tw"> \
                <span class="skill_notes_label">Pllop name:</span> \
                <input class="sne_pllop_name sninput" spellcheck="false" name="data[EA][pllop_name]" value="' + methods.getPllopName() + '" /> ';

       /*     b += '\
                <hr /> \
                <span class="skill_notes_label">Short description:</span> \
                <textarea style="height:30px;" class="sne_pllop_desc" spellcheck="false" name="data[EA][pllop_desc]">' + methods.getPllopDesc() + '</textarea>';
            */    
            b += '<hr /><span class="skill_notes_label">Published:</span> \
                  <p><input type="checkbox" class="sne_active snchk" ';
            if(methods.getPllopActive()) b += ' checked="checked" ';
            b += '/> Pllop is published and visible to others</p>';

            b += '\
                <hr /> \
                <span class="skill_notes_label">Pllop url address:</span><br /> \
                <div style="position:relative;"> \
                <span class="sne_profile_space_txt">pllop.it/</span> \
                <input class="sne_profile_space sninput disabled" spellcheck="false" name="data[EA][profile_space]" value="' + methods.getProfileSpace() + '" disabled="disabled" /> \
                <span class="sne_profile_space_txt">/</span> \
                <input class="sne_pllop_slug sninput" spellcheck="false" name="data[EA][pllop_slug]" value="' + methods.getPllopSlug() + '" /> \
                <span style="position:absolute;top:30px;left:90px;font-size:11px;color:#FFC000;">username</span><span style="position:absolute;top:30px;left:280px;font-size:11px;color:#FFC000;">pllop name</span>\
                <p style="color: #BBBBBB;margin-left: 50px;margin-top: 28px;width: 400px;"><input type="checkbox" class="sne_field_lock" /> I want to change my username and I understand that doing this will also change url addresses of <strong>all my other Pllops</strong>.</p>\
                </div>\
                <hr />\
                <span class="skill_notes_label">Pllop on a Facebook Page:</span>\
                <div class="fb_add"></div>\
                <hr /> \
                <span class="skill_notes_label">Google Analytics ID:</span> \
                <input class="sne_pllop_gaid sninput" spellcheck="false" name="data[EA][pllop_gaid]" value="' + methods.getGaId() + '" />  \
                <hr />\
                <span class="skill_notes_label">Delete this pllop:</span>\
                <a class="skill_notes_delete_site action">Delete it!</a></div>\
             <!--   <hr /> \
                <span class="skill_notes_label">Private:</span> \
                <input type="checkbox" class="sne_pllop_private sninput" spellcheck="false" name="data[EA][pllop_private]" value="" /> \
                <span class="skill_notes_label">Domain:</span> \
                <input class="sne_pllop_name" spellcheck="false" name="data[EA][pllop_domain]" value="" /> --> \
                </div></form>';
              
            $dest.html(b);
            
            $slug = $dest.find('input.sne_pllop_slug');
            
            $slug.bind('input',function(e) {
                slug_edited = true;
            });
            var $del = $dest.find('a.skill_notes_delete_site').click(function() {
                methods.deleteSite();
                return false;
            });
            var $pname = $dest.find('input.sne_pllop_name');
            $pname.bind('input',function(e) {
                set_name_on_save = false;
                if(!slug_edited) {
                    $slug.val(methods.makeSlug($(e.currentTarget).val()));
                }
            });            
            $dest.find('input').bind('input',function(e) {
                methods.dataForKeyChanged('site');
            });    
            $dest.find('input.snchk').bind('change',function(e) {
                methods.dataForKeyChanged('site');
            });                    
            $dest.find('input.sne_field_lock').change(function(e) {
                var $e = $(e.currentTarget);
                var $i = $dest.find('.sne_profile_space');
                var sel = $e.is(':checked');
                if(sel) {
                    $i.attr('disabled','');
                    $i.removeClass('disabled');
                } else {
                    $i.attr('disabled','disabled');
                    $i.addClass('disabled');
                }
            });    
            var $fb_dest = $dest.find('div.fb_add');
            
            var updateFb = function(fbd) {
                data.site.fb_page_id = fbd.fb_page_id ? fbd.fb_page_id : null;
                data.site.fb_page_name = fbd.fb_page_name ? fbd.fb_page_name : null;
                data.site.fb_page_app_id = fbd.fb_page_app_id ? fbd.fb_page_app_id : null;
            };
            
            var fbd = {tab_name : $pname.val()};
            if(data.site && data.site.fb_page_id) {
                fbd.fb_page_id = data.site.fb_page_id;
                fbd.fb_page_name = data.site.fb_page_name;
                fbd.fb_page_app_id = data.site.fb_page_app_id;
                msb.crsaui('showRemoveFromFbPage', $fb_dest, fbd, updateFb);
            } else {
                msb.crsaui('showAddToFbPage', $fb_dest, fbd, updateFb);
            }
        },
        showMyProfile : function($dest, d) {
            var b = '<hr style="margin-top:0px;"/><form><div class="skill_notes_tw"> \
                <span class="skill_notes_label">My Name:</span> \
                <input class="sne_profile_name sninput" spellcheck="false" name="data[EA][profile_name]" value="' + methods.getProfileName() + '" /> \
                <hr /> \
                <span class="skill_notes_label">My Email:</span> \
                <input class="sne_profile_email sninput" spellcheck="false" name="data[EA][profile_email]" value="' + methods.getProfileEmail() + '" /> \
              <!--  <hr /> \
                <span class="skill_notes_label">My Pllop Space / Username:</span> \
                <p><input type="checkbox" class="sne_field_lock" /> I know that changing my username will also change url addresses of all my Pllops.</p>\
                <span class="sne_profile_space_txt">pllop.it/</span><input class="sne_profile_space sninput disabled" spellcheck="false" name="data[EA][profile_space]" value="' + methods.getProfileSpace() + '" disabled="disabled" /> \
               <hr /> \
                <span class="skill_notes_label">Private:</span> \
                <input type="checkbox" class="sne_pllop_private sninput" spellcheck="false" name="data[EA][pllop_private]" value="" /> \
                <span class="skill_notes_label">Domain:</span> \
                <input class="sne_pllop_name" spellcheck="false" name="data[EA][pllop_domain]" value="" /> --> \
                </div></form>';
              
            $dest.html(b);
            
            $dest.find('input.sne_profile_name').bind('input',function(e) {
            });            
            $dest.find('input').bind('input',function(e) {
                methods.dataForKeyChanged('profile');
            });      
            /*  
            $dest.find('input.sne_field_lock').change(function(e) {
                var $e = $(e.currentTarget);
                var $i = $e.parent().next().next('input');
                var sel = $e.is(':checked');
                if(sel) {
                    $i.attr('disabled','');
                    $i.removeClass('disabled');
                } else {
                    $i.attr('disabled','disabled');
                    $i.addClass('disabled');
                }
            });    
              */
        },
        showNavigation : function($dest, d) {
            var $logo = $('div.crsa-logo');

            var b = '<hr style="margin-top:0px;"/>';

            if(d.upload) {
                b += '<div class="skill_notes_tw">';
                b += '<span class="skill_notes_label">Logo (image should not be too big):</span>';
                b += '<a class="skill_notes_upload_logo crsa-button">Upload logo</a>&nbsp;<a class="skill_notes_remove_logo action" href="#">remove logo</a></div><hr />';
            }

            b += '<form><div class="skill_notes_tw"> \
            ';
            b += '<span class="skill_notes_label">The menu:</span> \
                  <p><input type="checkbox" class="sne_show_menu snchk" ';
            if(methods.getShowMenu()) b += ' checked="checked" ';
            b += '/> Yes, show the menu (set page names in Options tab)</p>';
                        
            b += '<div class="menu_app"></div>\
                </div>';
                
                
            b += '</form>';
              
            $dest.html(b);
            
            var $menu_app = $dest.find('div.menu_app');
            
            $dest.find('input.snchk').bind('input',function(e) {
                methods.dataForKeyChanged('site');
            });      
            $dest.find('input.sne_show_menu').bind('change',function(e) {
                var show = $(e.currentTarget).is(':checked');
                var $m = $('div.crsa-menu');
                if(show) {
                    $m.removeClass('hidden');
                    $menu_app.show();
                } else {
                    $m.addClass('hidden');
                    $menu_app.hide();
                }
            });      
            var menu_id = data.site.main_menu_id ? data.site.main_menu_id : 0;
            if(menu_id) {
                var $m = $('div.crsa-menu');
                methods.loadSlideData($m, menu_id, function(r) {
                   var ma = $dest.find('.menu_app');
                   msb.crsaui('onEdit', null, $m[0].id, ma, null, $m, true);
                   methods.setMaxHeightOnAccordion($dest.closest('div.skill_notes'), $dest);
                });
            }
            $dest.find('a.skill_notes_upload_logo').click(function(e) {
                msb.crsaui('showFileUpload', {notify_element: $logo[0].id}, $logo, e);
                return false;
            });
            $logo.bind('FileUploaded', function(event, file, r) {
                var s = 'normal';
                if(r.info && s in r.info) {
                    var url = r.info[s].url;
                    var w = r.info[s].width;
                    var h = r.info[s].height;
                    
                    $logo.html('<img src="' + url + '" />');
                    data['site']['logo_id'] = r.id;
                    methods.dataForKeyChanged('site');
                    
                    methods.logEvent('Logo uploaded');
                }
            });     
            
            $dest.find('a.skill_notes_remove_logo').click(function(e) {
                data['site']['logo_id'] = 'none';
                methods.dataForKeyChanged('site');
                $logo.find('img').remove();
                return false;
            });
            
            
        },
        showPageOptions : function($dest, d) {
            var b = '<hr style="margin-top:0px;"/><form><div class="skill_notes_tw"> \
                <span class="skill_notes_label">Page name:</span> \
                <input class="sne_page_name sninput" spellcheck="false" value="' + methods.getPageName(d.key) + '" /> \
                <hr />';
                
            b += '<span class="skill_notes_label">Hide this page:</span> \
                  <p><input type="checkbox" class="sne_hide" ';
            if(methods.getHide(d.key)) b += ' checked="checked" ';
            b += '/> Do not show this page to others</p>';
            
            b += '</div></form>';
              
            $dest.html(b);
            
            $dest.find('input').bind('input',function(e) {
                methods.dataForKeyChanged(d.key);
            });    
            
            var $m = $('div.crsa-menu');
            
            $dest.find('input.sne_page_name').bind('input',function(e) {
                var t = $(e.currentTarget).val();
                $el = $dest.closest('div.crsa-slide');
                msb.crsalive('updatePageAnchor', $el, t);
                msb.crsaruntime('generateMenu', $m);
            });               
        },
        showPages : function($dest, d) {
            var items = msb.find('> div.crsa-slide');
            var lis = '';
            items.each(function(i,e) {
                var $e = $(e);
                var pid = $e.attr('data-crsa-id');
                var t = $e.find('h1').text();
                if(t) t = '<strong>' + t.substr(0,20) + '</strong> ';
                var p = $e.find('p').text();
                if(p) p = p.substr(0,30) + '...';
                
//                var n = $e.attr('data-crsa-name') + t + p;
                var n = t + p;
                lis += '<li id="lid_' + pid + '">' + n + '</li>';
            });
            
            var b = '<hr style="margin-top:0px;"/><form><div class="skill_notes_tw"> \
                <!-- <div class="skill_notes_pages_note">Save changes and reload the pllop to show pages in the new order</div> -->\
                <span class="skill_notes_label">Reorder pages with drag &amp; drop:</span> \
                <input type="hidden" class="sne_pages_order sninput" />';
                
            b += '<ul class="skill_notes_pages">' + lis + '</ul>';
            
            b += '</div></form>';
              
            $dest.html(b);
            
            
            var $slide = $dest.closest('div.crsa-slide');
            var slide_id = $slide.attr('id');
            
            var $plis = $dest.find('ul.skill_notes_pages');
            $plis.sortable({
                update: function(event, ui) {
                   /* items.each(function(i,e) {
                        $(e).detach();
                    });*/
                    var ord = '';
                    var $prev = null;
                    $plis.children().each(function(i,e) {
                        if(ord) ord += ',';
                        var id = e.id.replace('lid_','');
                        ord += id;
                        var $e = msb.find('.crsa-id-' + id);
/*                        if(elid2slide_el[id]) {
                            var $e = elid2slide_el[id];
                        } else {
                             
                        }
                        msb.append($e);*/
                        
                        if($prev == null) {
                            msb.prepend($e);
                        } else {
                            $prev.after($e);
                        }
                        $prev = $e;
                    });
                    $dest.find('input.sne_pages_order').val(ord);
                    methods.dataForKeyChanged('site');
                    
                    $slide = $('#' + slide_id);
                    var ni = $slide.index();
                    console.log('nind = ' + ni + ' ' + slide_id);
                    $(window).trigger('resize');
                    msb.crsaruntime('initNavigation');
                //    msb.crsaruntime('onItemActivated', ni, $slide);
                    msb.crsaruntime('gotoPage', $slide);
                }
            });
            $plis.disableSelection();
            
            $dest.find('input').bind('input',function(e) {
                methods.dataForKeyChanged('site');
            });    
        },
        dataForKeyChanged : function(key, content) {
            if(typeof content == 'undefined') content = false;
            if(content) content_changed[key] = true;
            if((!(key in changed)) || changed[key] == false) {
                changed[key] = true;
                $('#msb').trigger('crsaNotesUpdateChanged');
            }
        },
        loadSlideData : function($e, id, func) {
            var d = $e.data('crsa');
            if(d) {
                func();
                return;
            }
            msb.crsa('getObjectData', id, function(r) {
                func(r);
            });
        },
        adminFunc : function(func) {
            if($.fn.crsa) {
                if($('#msb').crsa('isInit')) {
                    if(typeof func == 'function') func();
                } else {
                    msb.crsaruntime('initCrsaInline', function() {
                        if(typeof func == 'function') func();
                    });                
                }
            } else {
                console.log('loading crsa');
                $.getScript('/23/javascript.js?modul=jqueryui,crsa,upload&gui=1', function() {
                    msb.crsaruntime('initCrsaInline', function() {
                        if(typeof func == 'function') func();
                    })
                });
                $("head").append($("<link rel='stylesheet' href='/23/style.css?modul=jqueryui,dv_gui&gui=1' type='text/css' media='screen' />"));
            }
        },
        updateChanged : function($e, key) {
            if(changed[key] || changed['site'] || changed['profile']) {
                $e.addClass('skill_notes_changed');
            } else {
                $e.removeClass('skill_notes_changed');
            }
        },
        makeSlug : function(str) {
              str = str.replace(/^\s+|\s+$/g, ''); // trim
              str = str.toLowerCase();
              
              // remove accents, swap ñ for n, etc
              var from = "àáäâèéëêìíïîòóöôùúüûñç·/_,:;";
              var to   = "aaaaeeeeiiiioooouuuunc------";
              for (var i=0, l=from.length ; i<l ; i++) {
                str = str.replace(new RegExp(from.charAt(i), 'g'), to.charAt(i));
              }

              str = str.replace(/[^a-z0-9 -]/g, '') // remove invalid chars
                .replace(/\s+/g, '-') // collapse whitespace and replace by -
                .replace(/-+/g, '-'); // collapse dashes

              return str;
        },
        getShowText : function(key, len) {
            if(len == 0) return '';
            var c = methods.getContent(key);
            if(c.length == 0) return '';
            if(c.length > len) {
                c = c.substr(0,len) + '...';
                c = c.replace(/\n/g, ' ');
            }
            return methods.autop(c);
        },
        getShowTitle : function(key) {
            var c = methods.getTitle(key);
            return c;
        },
        save : function(key, did) {
            if(typeof key == 'undefined') key = false;
            
            $('#msb').trigger('crsaNotesBeforeSave');
            
            var d = {};
            if(key) {
                alert('unsuported - saving only one key');
                var a = msb.crsaui('getChanges');
                $.each(a.elements, function(elid,v) {
                    var con = 'msb';
                    elid = elid.replace('id_','');
                    var k = elid in elid2key ? elid2key[elid] : null;
                    if(k != null && k == key) {
                        if(!(k in data)) data[k] = {};
                        data[k][con] = v;
                    }
                });
            } else {
                key = 0;
                var a = msb.crsaui('getChanges');
                var menu_id = data.site.main_menu_id ? data.site.main_menu_id : 0;
                $.each(a.elements, function(elid,v) {
                    var con = 'msb';
                    elid = elid.replace('id_','');
                    if(elid == menu_id) {
                        var k = 'site';
                        con = 'menu_msb';
                    } else {
                        var k = elid in elid2key ? elid2key[elid] : null;
                    }
                    if(k != null) {
                        if(!(k in data)) data[k] = {};
                        data[k][con] = v;
                    }
                });
            }
            $.ajax({
                  type: 'POST',
                  url: settings.url_base + settings.save_data + did + '/' + key,
                  data: {notes: JSON.stringify(data)},
                  success: function(ret) {
                      if(ret.status == 'login') {
                          msb.crsaruntime('invalidateLogin');
                          $('#msb').crsaruntime('userRegistration', 'log');
                      } else if(ret.status == 'error') {
                          alert(ret.error);
                      } else {
                          if(!key) {
                              changed = {};
                              content_changed = {};
                          } else {
                              changed[key] = false;
                              content_changed[key] = false;
                          }
                          $('#msb').trigger('crsaNotesUpdateChanged');
                          $('#msb').trigger('crsaNotesSaved', [key]);
                          $('#msb').crsaui('saveDone');
                          methods.logEvent('Changes saved');

                          if(ret.redirect) {
                              methods.logPause();
                              msb.crsaruntime('waitStart');
                              window.location = ret.redirect;
                              return;
                          }
                      }
                      $('#msb').crsaruntime('waitDone');
                  },
                  error: function(a,b,c) {
                      $('#msb').crsaruntime('waitDone');
                      alert(a.responseText);
                  },
                  beforeSend:function(request) { 
                      request.setRequestHeader('X-Update', 'dummy');
                  },               
                  dataType: 'json'
                });               
        },
        saveBck : function(key, pid) {
            $('#msb').crsaruntime('waitStart');
            $.ajax({
                  type: 'POST',
                  url: settings.url_base + settings.save_data_bck + key + '/' + pid,
                  data: {},
                  success: function(ret) {
                      if(ret.status == 'login') {
                          msb.crsaruntime('invalidateLogin');
                          $('#msb').crsaruntime('userRegistration', 'log');
                      } else {
                      }
                      $('#msb').crsaruntime('waitDone');
                  },
                  error: function(a,b,c) {
                      $('#msb').crsaruntime('waitDone');
                      alert(a.responseText);
                  },
                  beforeSend:function(request) { 
                      request.setRequestHeader('X-Update', 'dummy');
                  },               
                  dataType: 'json'
                });               
        },
        deleteSite : function() {
            if(confirm('Do you really want to delete this pllop? Once it is deleted, you can\'t get it back!')) {
                $('#msb').crsaruntime('waitStart');
                
                $.ajax({
                      type: 'POST',
                      url: settings.url_base + settings.delete_site,
                      data: {},
                      success: function(ret) {
                          if(ret.status == 'login') {
                              msb.crsaruntime('invalidateLogin');
                              $('#msb').crsaruntime('userRegistration', 'log');
                          } else {
                              alert('This pllop was deleted.');
                              window.location = 'http://pllop.it';
                          }
                          $('#msb').crsaruntime('waitDone');
                      },
                      error: function(a,b,c) {
                          $('#msb').crsaruntime('waitDone');
                          alert(a.responseText);
                      },
                      beforeSend:function(request) { 
                          request.setRequestHeader('X-Update', 'dummy');
                      },               
                      dataType: 'json'
                    });               
            }
        },
        hideNotes : function($s, fast) {
            //var $s = $e.find('.skill_notes');
            if(!fast) {
                $s.fadeOut(500, function() {
                    methods.closeEditor($s);
                    $s.remove();
                });
            } else {
                methods.closeEditor($s);
                $s.remove();
            }
        },
        closeEditor : function($s) {
           var $content = $s.find('textarea.sne_content');
           var edd = $content.data('crsaEditor');
           if(edd) {
               clearInterval(edd.Interval);
               edd.Editor.remove();
               console.log('remove ed');
           }
           
        },
        sizeTextarea : function($e) {
            if($e.hasClass('skill_notes_inline')) return;
            var wh = $('#msb').crsaruntime('getWindowHeight');
            var h = wh - 50 - 80;
            $e.css('height',h + 'px').css('top','65px');
            
            var $t = $e.find('textarea.sne_content');

            
            var edd = $t.data('crsaEditor');
            if(edd) {
                //console.log(nh);
                $t = $('#' + $t[0].id + '_ifr')
                var p = $t.offset();
                var bd = 70;
                var nh = h - p.top - bd;
                if(nh < 100) nh = 80;
                
                $t.css('height', nh + 'px');
              // edd.Editor.hide();
              // edd.Editor.render();
            } else {
                var p = $t.offset();
                var bd = 70;
                var nh = h - p.top - bd;
                if(nh < 100) nh = 80;
                $t.css('height', nh + 'px');
            }
            var $sn = $e.find('div.skill_notes');
            methods.setMaxHeightOnAccordion($sn, $sn);
            
            $e.find('div.sntbc > div').css('max-height',(h - 100) + 'px');
           
        }
    };


         
    $.fn.crsanotes = function( method ) {

    if ( methods[method] ) {
      return methods[method].apply( this, Array.prototype.slice.call( arguments, 1 ));
    } else if ( typeof method === 'object' || ! method ) {
      return methods.init.apply( this, arguments );
    } else {
      $.error( 'Method ' +  method + ' does not exist on jQuery.crsa' );
    }    

    };

})( jQuery );