var PgCSSActiveRulesView = function () {
    var $element = $('<div id="crsa-css-active-rules" class="crsa-css-active-rules rule-list crsa-stylesheets"></div>');

    var view = new PgUIView($element);
    var pgCSSActiveRulesEditor = null;

    this.view = view;

    var showCssActiveRules = function (selectedElement) {
        selectedElement = selectedElement || pinegrow.getSelectedElement();

        if (pgCSSActiveRulesEditor && pgCSSActiveRulesEditor.ready) {
            pgCSSActiveRulesEditor.remove();
        }

        pgCSSActiveRulesEditor = new PgCSSActiveRulesEditor(selectedElement, $element);
        if (pgCSSActiveRulesEditor.ready) pgCSSActiveRulesEditor.show();
    }

    //will be auto-offed on destroy
    view.on('crsa-element-selected', function(event, pgel) {
        view.whenVisible(function() {
            showCssActiveRules(pgel);
        })
    });

    pinegrow.addEventHandler('on_css_source_changed', function (p, obj) {
        view.whenVisible(function() {
            if (obj && obj.by == 'active_css') return;
            showCssActiveRules();
        })
    });

    view.on('crsa-stylesheets-changed', function (event, obj) {
        view.whenVisible(function() {
            if (obj && obj.by == 'active_css') return;
            showCssActiveRules();
        })
    });

}